#ifndef _DYN_MANAGER_REGISTERS_H
#define _DYN_MANAGER_REGISTERS_H

#define RAM_DYN_MANAGER_LENGTH                8

#define DYN_MANAGER_NUM_MODULES_OFFSET        0
#define DYN_MANAGER_NUM_MASTERS_OFFSET        1
#define DYN_MANAGER_CONTROL_OFFSET            2 //   bit 7  |  bit 6  | bit 5 | bit 4 | bit 3 |    bit 2   | bit 1 | bit 0
                                                // scanning | running |       |       |       | start scan | stop  | start 
#define DYN_MANAGER_START                     0x01
#define DYN_MANAGER_STOP                      0x02
#define DYN_MANAGER_START_SCAN                0x04
#define DYN_MANAGER_RUNNING                   0x40
#define DYN_MANAGER_SCANNING                  0x80

#define DYN_MANAGER_NUM_DEVICES_OFFSET        3
#define DYN_MANAGER_PRESENT_DEVICES           4

#define EEPROM_DYN_MANAGER_LENGTH             1

#define DYN_MANAGER_PERIOD_OFFSET             0

#define dyn_manager_eeprom_data(name,section_name,base_address,DEFAULT_PERIOD) \
unsigned short int name##_eeprom_data[] __attribute__ ((section (section_name))) __attribute__ ((aligned (4)))={ \
  DEFAULT_PERIOD&0x00FF,base_address+DYN_MANAGER_PERIOD_OFFSET \
};

#endif

