#ifndef _GRIPPERS_H
#define _GRIPPERS_H

#ifdef __cplusplus
extern "C" {
#endif

#include "stm32f1xx.h"
#include "motion_manager.h"

typedef enum {GRIPPER_LEFT,GRIPPER_RIGHT} grippers_t;

// public functions
void grippers_init(uint16_t period_us);
void grippers_set_period(uint16_t period_us);
uint16_t grippers_get_period(void);
void grippers_open(grippers_t gripper);
void grippers_close(grippers_t gripper);
void grippers_stop(grippers_t gripper);
uint8_t gripper_is_open(grippers_t gripper);
uint8_t gripper_is_close(grippers_t gripper);
uint8_t gripper_is_moving(grippers_t gripper);

// operation functions
uint8_t grippers_in_range(unsigned short int address, unsigned short int length);
void grippers_process_read_cmd(unsigned short int address,unsigned short int length,unsigned char *data);
void grippers_process_write_cmd(unsigned short int address,unsigned short int length,unsigned char *data);
void grippers_process(void);

#ifdef __cplusplus
}
#endif

#endif
