#ifndef _WALK_REGISTERS_H
#define _WALK_REGISTERS_H

#define RAM_WALK_LENGTH                    4

#define WALK_CONTROL                         0// bit 7 | bit 6 | bit 5 |  bit 4  | bit 3 | bit 2 |     bit 1    |    bit 0
                                            // current phase           walking                   stop walking   start walking
  #define WALK_START                       0x01
  #define WALK_STOP                        0x02
  #define WALK_RUNNING                     0x10
  #define WALK_CURRENT_PHASE               0xC0
#define WALK_STEP_FW_BW                    1
#define WALK_STEP_LEFT_RIGHT               2
#define WALK_STEP_DIRECTION                3

#define EEPROM_WALK_LENGTH                 33

#define WALK_X_OFFSET                      0
#define WALK_Y_OFFSET                      1
#define WALK_Z_OFFSET                      2
#define WALK_ROLL_OFFSET                   3
#define WALK_PITCH_OFFSET                  4
#define WALK_YAW_OFFSET                    5
#define WALK_HIP_PITCH_OFFSET              6
#define WALK_PERIOD_TIME                   8
#define WALK_DSP_RATIO                     10
#define WALK_STEP_FW_BW_RATIO              11
#define WALK_FOOT_HEIGHT                   12
#define WALK_SWING_RIGHT_LEFT              13
#define WALK_SWING_TOP_DOWN                14
#define WALK_PELVIS_OFFSET                 15
#define WALK_ARM_SWING_GAIN                16
#define WALK_MAX_VEL                       17
#define WALK_MAX_ROT_VEL                   18
#define WALK_R_HIP_YAW_SERVO_ID            19
#define WALK_R_HIP_ROLL_SERVO_ID           20
#define WALK_R_HIP_PITCH_SERVO_ID          21
#define WALK_R_KNEE_SERVO_ID               22
#define WALK_R_ANKLE_PITCH_SERVO_ID        23
#define WALK_R_ANKLE_ROLL_SERVO_ID         24
#define WALK_R_SHOULDER_PITCH_SERVO_ID     25
#define WALK_L_HIP_YAW_SERVO_ID            26
#define WALK_L_HIP_ROLL_SERVO_ID           27
#define WALK_L_HIP_PITCH_SERVO_ID          28
#define WALK_L_KNEE_SERVO_ID               29
#define WALK_L_ANKLE_PITCH_SERVO_ID        30
#define WALK_L_ANKLE_ROLL_SERVO_ID         31
#define WALK_L_SHOULDER_PITCH_SERVO_ID     32


#define walk_eeprom_data(name,section_name,base_address,DEFAULT_X_OFFSET,DEFAULT_Y_OFFSET,DEFAULT_Z_OFFSET,DEFAULT_ROLL_OFFSET,DEFAULT_PITCH_OFFSET,DEFAULT_YAW_OFFSET,DEFAULT_HIP_PITCH_OFFSET,DEFAULT_PERIOD_TIME,DEFAULT_DSP_RATIO,DEFAULT_STEP_FW_BW_RATIO,DEFAULT_FOOT_HEIGHT,DEFAULT_SWING_RIGHT_LEFT,DEFAULT_SWING_TOP_DOWN,DEFAULT_PELVIS_OFFSET,DEFAULT_ARM_SWING_GAIN,DEFAULT_MAX_VEL,DEFAULT_MAX_ROT_VEL,DEFAULT_R_HIP_YAW_SERVO_ID,DEFAULT_R_HIP_ROLL_SERVO_ID,DEFAULT_R_HIP_PITCH_SERVO_ID,DEFAULT_R_KNEE_SERVO_ID,DEFAULT_R_ANKLE_PITCH_SERVO_ID,DEFAULT_R_ANKLE_ROLL_SERVO_ID,DEFAULT_R_SHOULDER_PITCH_SERVO_ID,DEFAULT_L_HIP_YAW_SERVO_ID,DEFAULT_L_HIP_ROLL_SERVO_ID,DEFAULT_L_HIP_PITCH_SERVO_ID,DEFAULT_L_KNEE_SERVO_ID,DEFAULT_L_ANKLE_PITCH_SERVO_ID,DEFAULT_L_ANKLE_ROLL_SERVO_ID,DEFAULT_L_SHOULDER_PITCH_SERVO_ID) \
unsigned short int name##_eeprom_data[] __attribute__ ((section (section_name))) __attribute__ ((aligned (4)))= {\
  DEFAULT_X_OFFSET,base_address+WALK_X_OFFSET, \
  DEFAULT_Y_OFFSET,base_address+WALK_Y_OFFSET, \
  DEFAULT_Z_OFFSET,base_address+WALK_Y_OFFSET, \
  DEFAULT_ROLL_OFFSET,base_address+WALK_ROLL_OFFSET, \
  DEFAULT_PITCH_OFFSET,base_address+WALK_PITCH_OFFSET, \
  DEFAULT_YAW_OFFSET,base_address+WALK_YAW_OFFSET, \
  DEFAULT_HIP_PITCH_OFFSET&0x00FF,base_address+WALK_HIP_PITCH_OFFSET, \
  (DEFAULT_HIP_PITCH_OFFSET>>8)&0x00FF,base_address+WALK_HIP_PITCH_OFFSET+1, \
  DEFAULT_PERIOD_TIME&0x00FF,base_address+WALK_PERIOD_TIME, \
  (DEFAULT_PERIOD_TIME>>8)&0x00FF,base_address+WALK_PERIOD_TIME+1, \
  DEFAULT_DSP_RATIO,base_address+WALK_DSP_RATIO, \
  DEFAULT_STEP_FW_BW_RATIO,base_address+WALK_STEP_FW_BW_RATIO, \
  DEFAULT_FOOT_HEIGHT,base_address+WALK_FOOT_HEIGHT, \
  DEFAULT_SWING_RIGHT_LEFT,base_address+WALK_SWING_RIGHT_LEFT, \
  DEFAULT_SWING_TOP_DOWN,base_address+WALK_SWING_TOP_DOWN, \
  DEFAULT_PELVIS_OFFSET,base_address+WALK_PELVIS_OFFSET, \
  DEFAULT_ARM_SWING_GAIN,base_address+WALK_ARM_SWING_GAIN, \
  DEFAULT_MAX_VEL,base_address+WALK_MAX_VEL, \
  DEFAULT_MAX_ROT_VEL,base_address+WALK_MAX_ROT_VEL, \
  DEFAULT_R_HIP_YAW_SERVO_ID,base_address+WALK_R_HIP_YAW_SERVO_ID, \
  DEFAULT_R_HIP_ROLL_SERVO_ID,base_address+WALK_R_HIP_ROLL_SERVO_ID, \
  DEFAULT_R_HIP_PITCH_SERVO_ID,base_address+WALK_R_HIP_PITCH_SERVO_ID, \
  DEFAULT_R_KNEE_SERVO_ID,base_address+WALK_R_KNEE_SERVO_ID, \
  DEFAULT_R_ANKLE_PITCH_SERVO_ID,base_address+WALK_R_ANKLE_PITCH_SERVO_ID, \
  DEFAULT_R_ANKLE_ROLL_SERVO_ID,base_address+WALK_R_ANKLE_ROLL_SERVO_ID, \
  DEFAULT_R_SHOULDER_PITCH_SERVO_ID,base_address+WALK_R_SHOULDER_PITCH_SERVO_ID, \
  DEFAULT_L_HIP_YAW_SERVO_ID,base_address+WALK_L_HIP_YAW_SERVO_ID, \
  DEFAULT_L_HIP_ROLL_SERVO_ID,base_address+WALK_L_HIP_ROLL_SERVO_ID, \
  DEFAULT_L_HIP_PITCH_SERVO_ID,base_address+WALK_L_HIP_PITCH_SERVO_ID, \
  DEFAULT_L_KNEE_SERVO_ID,base_address+WALK_L_KNEE_SERVO_ID, \
  DEFAULT_L_ANKLE_PITCH_SERVO_ID,base_address+WALK_L_ANKLE_PITCH_SERVO_ID, \
  DEFAULT_L_ANKLE_ROLL_SERVO_ID,base_address+WALK_L_ANKLE_ROLL_SERVO_ID, \
  DEFAULT_L_SHOULDER_PITCH_SERVO_ID,base_address+WALK_L_SHOULDER_PITCH_SERVO_ID};

#endif

